local BaikCore = LibStub("AceAddon-3.0"):GetAddon("BaikCore")
local BaikUnitFrame = BaikCore.BaikUnitFrame
local Database = BaikCore.Database
local Log = BaikCore.Log
local Option = BaikCore.Option
local RootStatusBar = BaikCore.StatusBar

-- Add Module
local StatusBar = BaikUnitFrame:NewModule("StatusBar")

-- Constants
local UNIT_TEXTURE_DB = "unit_status_bar"

local function GetOpt()
    return RootStatusBar:GetOpts("StatusBar", UNIT_TEXTURE_DB)
end

local STATUSBARS = {
    -- Player
    PlayerFrameHealthBar,
    PlayerFrameManaBar,
    PlayerFrameAlternateManaBar,
    CastingBarFrame,
    -- Target
    TargetFrameHealthBar,
    TargetFrameManaBar,
    TargetFrameSpellBar,
    -- Focus
    FocusFrameHealthBar,
    FocusFrameManaBar,
    FocusFrameSpellBar,
}

-- Ace3 Callbacks
function StatusBar:OnInitialize()
    Log:v("StatusBar_OnInitialize")
    Database:InitIfEmpty(UNIT_TEXTURE_DB, RootStatusBar.DEFAULT)
    Option:AddOption(BaikUnitFrame.OPTION_NAME, "status_bar", GetOpt())
    RootStatusBar:AddBars(STATUSBARS, UNIT_TEXTURE_DB)
end

function StatusBar:OnEnable()
    Log:v("StatusBar_OnEnable")
    RootStatusBar:SyncCategory(UNIT_TEXTURE_DB)
end

function StatusBar:OnDisable()
    Log:v("StatusBar_OnDisable")
end
